#!usr/bin/env python
#dataexplorer.py
#Maintained by W.Yang
#
#A GUI to view the data of projects, jobs and facts
#
#CVS Id $Id: dataexplorer.py,v 1.10 2005/09/23 09:16:02 wy45 Exp $

from Tkinter import *
import MySQLdb
import traceback
import exceptions

root = Tk()
root.title('Project Data Explorer')


class App:
    def __init__(self,master):
        # global valiable
        self.sele_pro = ''      
        self.sele_job = ''
        
        # construct frame  
        f1 = Frame(master)
        f1.pack(side=TOP,expand=YES,fill=BOTH)
       # f1.pack(side=TOP,fill=X)
        l1 = Label(f1,text='Projects',width=30)
       # l1 = Label(f1,text='Projects')
        l1.pack(side=LEFT,expand=YES,fill=BOTH)
     #   l1.pack(side=LEFT,fill=BOTH)

        l2 = Label(f1,text='Jobs',width=30)
        l2.pack(side=LEFT,expand=YES,fill=BOTH)
      #  l2.pack(side=LEFT,fill=BOTH)


        l3 = Label(f1,text='Facts',width=30)
        l3.pack(side=LEFT,expand=YES,fill=BOTH)
      #  l3.pack(side=LEFT,fill=BOTH)

        f2 = Frame(master)
        f2.pack(side=TOP,expand=YES,fill=BOTH)
       # f2.pack(side=TOP,fill=X)

        f21 = Frame(f2)
        f21.pack(side=LEFT,expand=YES,fill=BOTH)

        sbar1 = Scrollbar(f21)
        self.lb1 = Listbox(f21,width=30,height=20)
      #  self.lb1 = Listbox(f21,width=35)

        sbar1.config(command=self.lb1.yview)
        self.lb1.config(yscrollcommand=sbar1.set)
        sbar1.pack(side=RIGHT,fill=Y)
        self.lb1.pack(side=LEFT,expand=YES,fill=BOTH)

        self.lb1.bind('<Double-1>',self.handleproject)
        
        f22 = Frame(f2)
        f22.pack(side=LEFT,expand=YES,fill=BOTH)
        sbar2 = Scrollbar(f22)
        self.lb2 = Listbox(f22,width=30,height=20)
      #  self.lb2 = Listbox(f22,width=35)
        sbar2.config(command=self.lb2.yview)
        self.lb2.config(yscrollcommand=sbar2.set)
        sbar2.pack(side=RIGHT,fill=Y)
        self.lb2.pack(side=LEFT,expand=YES,fill=BOTH)
        self.lb2.bind('<Double-1>',self.handlejob)

        f23 = Frame(f2)
        f23.pack(side=LEFT,expand=YES,fill=BOTH)
        sbar3 = Scrollbar(f23)
        self.lb3 = Listbox(f23,width=30,height=20)        
     #   self.lb3 = Listbox(f23,width=35)        
        sbar3.config(command=self.lb3.yview)
        self.lb3.config(yscrollcommand=sbar3.set)
        sbar3.pack(side=RIGHT,fill=Y)
        self.lb3.pack(side=LEFT,expand=YES,fill=BOTH)
       
        f3 = Frame(master)
        f3.pack(side=TOP,expand=YES,fill=BOTH)
     #   f3.pack(side=TOP,fill=X)
        self.b1 = Button(f3,text='Refresh Project List',width=10,command=self.displayproject)
        self.b1.pack(side=LEFT,expand=YES,fill=BOTH)

        self.b2 = Button(f3,text='Refresh Job List',command=self.refreshjob, width=10)
        self.b2.pack(side=LEFT,expand=YES,fill=BOTH)

        self.b3 = Button(f3,text='Refresh Fact List',command=self.refreshfact,width=10)
        self.b3.pack(side=LEFT,expand=YES,fill=BOTH)

        self.displayproject()

    def getproject(self):
        try:
            db = MySQLdb.connect(host='localhost',user='admin',passwd='admin',db='ProjectHistory')
            cursor = db.cursor()
            sql = 'select project_name,start_date from projects order by start_date desc'
            cursor.execute(sql)
            result = cursor.fetchall()
            
        except exceptions.Exception, e:
            print 'catch exception:%s' % str(e)
            
        return result
    
    def getjob(self,project):
        joblist = ''
        try:
            db = MySQLdb.connect(host='localhost',user='admin',passwd='admin',db='ProjectHistory')
            cursor = db.cursor()
            sql1 = 'select project_id from projects where project_name=\''+MySQLdb.escape_string(project)+'\''
            cursor.execute(sql1)
            pro_id = cursor.fetchone()
            pro_id = str(pro_id)
            
            # get rid of ( and ,
            pro_id = pro_id[1:-3]
        
            sql2 = 'select job_id, job_name,start_date from jobs where project_id = '+ pro_id+' order by start_date desc'
            cursor.execute(sql2)
            joblist = cursor.fetchall()
            
        except exceptions.Exception, e:
            print 'catch exception: %s' % str(e)
    
        return joblist

    def getfact(self,jobid):
        try:
            db = MySQLdb.connect(host='localhost',user='admin',passwd='admin',db='ProjectHistory')
            cursor = db.cursor()
        
            sql2 = 'select name,value from facts where job_id = '+jobid+' order by name,fact_id desc'
            cursor.execute(sql2)
            factlist = cursor.fetchall()
            
        except exceptions.Exception, e:
            print 'catch exception:%s' % str(e)
            
        return factlist

    def displayproject(self):
     
        result = self.getproject()
    
        # delete all of the listbox content before load the data into listboxs
        self.lb1.delete(0,END)
        self.lb2.delete(0,END)
        self.lb3.delete(0,END)
        
        # re set sele_pro, sele_job
        self.sele_pro = ''
        self.sele_job = ''
       
        for item in result:
            self.lb1.insert(END,item)

    def displayjob(self,project):
       
        # delete the old content in the listbox
        self.lb3.delete(0,END)
        self.lb2.delete(0,END)
        
        result = self.getjob(project)
        for item in result:
            self.lb2.insert(END,item)

    def displayfact(self,jobid):
        #delete the old content in the listbox
        self.lb3.delete(0,END)
        result = self.getfact(jobid)
        for item in result:
            # add '=' between name and value
            line = str(item[0])+' = '+str(item[1])
            self.lb3.insert(END,line)

    def refreshjob(self):
        project = self.sele_pro

        #re set sele_job
        self.sele_job = ''
    
        if project != '':
            self.displayjob(project)

    def refreshfact(self):
        job = self.sele_job
        if job != '':
           self.displayfact(job)

    def handleproject(self,event):
        index = self.lb1.curselection()
    
        # get the content of clicked line
        line = self.lb1.get(index)
        line = str(line)
    
        # get the string of project name
        to = line.find(',')
        self.sele_pro = line[2:to-1]

        self.displayjob(self.sele_pro)

    def handlejob(self,event):
       index = self.lb2.curselection()

       # get the content of clicked line
       line = self.lb2.get(index)
       line = str(line)
  
       # get the string of job name
       to = line.find(',')
       self.sele_job = line[2:to-1]
       self.displayfact(self.sele_job) 
            
app = App(root)

root.mainloop()

