#!/usr/bin/env python
#server.py
#Maintained by W.Yang
#
#Database handler
#
#CVS Id $Id: server.py,v 1.26 2005/09/30 15:40:00 wy45 Exp $

import sys
import socket,traceback,os
from threading import *
import exceptions
import xml.dom.minidom
import xml.sax.saxutils as su
import db
import datetime

class messager:
   def __init__(self,flag=False):
      self.flag = flag
      self.file = open('handler_log.txt','a')
   def output(self,message):
      if self.flag:
         print message
      else:
         self.file.write(message)
   def close(self):
      self.file.close()
      
def version_check():
   version = sys.version_info
   if version[0] < 2 :
      return False
   elif version[0]==2 and version[1]< 3:
      return False
   else:
      return True

def response_wrapper(status,result):
   if type(result) == tuple:
      response = "<db_response><status>"+status+"</status>"

      for item in result:           
         response = response + "<result>"+su.escape(str(item))+"</result>"
      response = response+"</db_response>\n"
   else:
      response = "<db_response><status>"+status+"</status><result>"+su.escape(result)+"</result></db_response>\n"
   return response  

def doCommand(conn,command,argu):
   if command == 'OpenDB':
      try:             
         host = argu[0].childNodes[0].data
         user = argu[1].childNodes[0].data
         passwd = argu[2].childNodes[0].data
         db = argu[3].childNodes[0].data
                   
         result = conn.OpenDB(host,user,passwd,db)
         if result == 'successful':
            m.output('Database opened.')
            status = 'ok'
         else:
            m.output('No such database!')
            status = 'failed'
         
      except exceptions.Exception,e:
         m.output('\ncatch exception:')
         m.output(str(e))
         status = 'failed'
         result = 'Handler exception: '+str(e)
         m.output(result)

      response = response_wrapper(status,result)           
      return response 

   if command == 'IsOpen':
      try:
         result = str(conn.IsOpen())
         status = 'ok'
      except exceptions.Exception,e:
         m.output('\ncatch exception:')
         m.output(str(e))
         status = 'failed'
         result = 'Handler exception: '+ str(e)
      response = response_wrapper(status,result)
      return response
         
   if command == 'NewProject':
      project = argu[0].childNodes[0].data
   
      result_list = ['Exist','DB not open yet']
      try:
         result = conn.NewProject(project)
         result = str(result)      
         if result in result_list:
            status = 'failed'
            m.output(result)
         elif 'DB exception' in result:
            status = 'failed'
            m.output(result)
         else:
            status = 'ok'
            m.output(result)
            m.output('\nDone!')
      except exceptions.Exception,e:
         m.output('\ncatch exception:')
         m.output(str(e))
         result = 'Handler exception: '+str(e)
         status = 'failed'

      response = response_wrapper(status,result)
      return response
    
   if command == 'NewJob':            
      result_list = ['DB not open yet','No such a project']
      try:             
         projectname = argu[0].childNodes[0].data
         jobname = argu[1].childNodes[0].data

         result = conn.NewJob(projectname,jobname)
         result = str(result) 
         if result in result_list:
            status = 'failed'
            m.output(result)
         elif 'DB exception' in result:
            status = 'failed'
            m.output(result)
         else:
            status = 'ok'
            m.output(str(result))
            m.output('\nDone!') 
      except exceptions.Exception,e:
         m.output('\ncatch exception:')
         m.output(str(e)) 
         result = 'Handler exception: '+str(e)
         status = 'failed'

      response = response_wrapper(status,result)
      return response
    
   if command == 'SetData':
      result_list = ['DB not open yet']
      try:               
         jobid = argu[0].childNodes[0].data
         name = argu[1].childNodes[0].data
         value = argu[2].childNodes[0].data
                        
         result = conn.SetData(jobid,name,value)
         result = str(result)
         m.output(str(result))
         if result in result_list:
            status = 'failed'
            m.output(result)
         elif 'DB exception' in result:
            status = 'failed'
            m.output(result)
         else:
            status = 'ok'
            m.output(str(result))
            m.output('\nDone!') 
      except exceptions.Exception,e:
         m.output('\ncatch exception:')
         m.output(str(e))  
         result = 'Handler exception: '+str(e)
         status = 'failed'
      response = response_wrapper(status,result)
      return response

   if command == 'GetData':
      result_list = ['DB not open yet','Empty']
      try:
         jobid  = argu[0].childNodes[0].data
         name = argu[1].childNodes[0].data
         
         result = conn.GetData(jobid,name)
         result = su.escape(str(result))
         
         if result in result_list:
            status = 'failed'
            m.output(result)
         elif 'DB exception' in result:
            status = 'failed'
            m.output(result)
         else:
            status = 'ok'
            m.output(str(result))
            m.output('\nDone!') 
      except exceptions.Exception,e:
         m.output('catch exception:')
         m.output(str(e))
         status = 'failed'
         result = 'Handler exception: '+str(e)

      response = response_wrapper(status,result)
      return response
          
   if command == 'ListProjects':
      result_list = ['DB not open yet','Empty']
      try:
         result = conn.ListProjects()
         if result in result_list:
            status = 'failed'
            m.output(result)
         elif 'DB exception' in result:
            status = 'failed'
            m.output(result)
         else:
            status = 'ok'
   
            m.output('\nDone!')
            
      except exceptions.Exception,e:
         m.output('\ncatch exception:')
         m.output(str(e))
         result = 'Handler exception: '+str(e)
         status = 'failed'
      response = response_wrapper(status,result)
      return response
        
   if command == 'ListJobs':
      result_list = ['DB not open yet','Empty','No Exist']
      try:
         projectname = argu[0].childNodes[0].data
         result = conn.ListJobs(projectname)
         
         if result in result_list:
            status = 'failed'
            m.output(result)
         elif 'DB exception' in result:
            status = 'failed'
            m.output(result)  
         else:
            status = 'ok'
            m.output('\nDone!')    
      except exceptions.Exception,e:
         m.output('\ncatch exception:')
         m.output(str(e))   
         result = 'Handler exception: '+str(e)
         status = 'failed'

      response = response_wrapper(status,result)         
      return response
      
   if command == 'ListItems':
      result_list = ['DB not open yet','Empty']
      try:
         jobid = argu[0].childNodes[0].data
         result = conn.ListItems(jobid)
         
         if result in result_list:
            status = 'failed'
            m.output(result)
         elif 'DB exception' in result:
            status = 'failed'
            m.output(result) 
         else:
            status = 'ok'
            m.output('\nDone!') 
      except exceptions.Exception,e:
         m.output('\ncatch exception:')
         m.output(str(e))  
         
         result = 'Handler exception: '+str(e)
         status = 'failed'
         
      response = response_wrapper(status,result)         
      return response
            
   if command == 'ImportDingbat':
      result_list = ['DB not open yet']
      try:
         jobid = argu[0].childNodes[0].data
         name = argu[1].childNodes[0].data
         desc = argu[2].childNodes[0].data
         type = argu[3].childNodes[0].data
         value = argu[4].childNodes[0].data
         
         result = conn.ImportDingbat(jobid,name,desc,type,value)
         if result in result_list:
            status = 'failed'
            m.output(result)
         elif 'DB exception' in result:
            status = 'failed'
            m.output(result)  
         else:
            status = 'ok'
            m.output('\nDone!') 
      except exceptions.Exception,e:
         m.output('\ncatch exception:')
         m.output(str(e))
         result = 'Handler exception: '+str(e)
         status = 'failed'

      response = response_wrapper(status,result)       
      return response        
  
   if command == 'ExportDingbat':
      result_list = ['DB not open yet','Empty']
      try:
         jobid = argu[0].childNodes[0].data
         name = argu[1].childNodes[0].data
         result = conn.ExportDingbat(jobid,name)
            
         if result in result_list:
            status = 'failed'
            m.output(result)
         elif 'DB exception' in result:
            status = 'failed'
            m.output(result)
         else:
            status = 'ok'
            m.output('Done!') 
      except exceptions.Exception,e:
         m.output('catch exception:')
         m.output(str(e))
                
         result = 'Handler exception: '+str(e)
         status = 'failed'
         
      response = response_wrapper(status,result)        
      return response
         
   if command == 'DeleteDingbat':
      result_list = ['DB not open yet']
      try:
         jobid = argu[0].childNodes[0].data
         name = argu[1].childNodes[0].data
                 
         result = conn.DeleteDingbat(jobid,name)
         if result in result_list:
            status = 'failed'
            m.output(result)
         elif 'DB exception' in result:
            status = 'failed'
            m.output(result)
         else:
            status = 'ok'
            m.output('\nDone!') 
      except exceptions.Exception,e:
         m.output('\ncatch exception:')
         m.output(str(e)) 
              
         status = 'failed'
         result = 'Handler exception: '+str(e)
         
      response = response_wrapper(status,result)      
      return response
           
   if command == 'DescribeDingbat':
      result_list = ['DB not open yet']
      try:
         jobid = argu[0].childNodes[0].data
         name = argu[1].childNodes[0].data
                 
         result = conn.DescribeDingbat(jobid,name)
         if result in result_list:
            status = 'failed'
            m.output('\nNot such an item,please try again!')
         elif 'DB exception' in result:
            status = 'failed'
            m.output(result)
         else:
            status = 'ok'
            m.output('\nDone!') 
      except exceptions.Exception,e:
         m.output('\ncatch exception:')
         m.output(str(e)) 

         result = 'Handler exception: '+str(e)
         status = 'failed'

      response = response_wrapper(status,result)        
      return response
    
   if command == 'GetProject':
      try:
         projectname = argu[0].childNodes[0].data
         result = conn.GetProject(projectname)
         result = str(result)
         result_list = ['No Exist','DB not open yet']
         if result in result_list:
            status ='failed'
            m.output(result)
         elif 'DB exception' in result:
            status = 'failed'
            m.output(result)    
         else:
            status = 'ok'
            m.output(result)
            m.output('\nDone')
            
      except exceptions.Exception, e:
         m.output('\ncatch exception:')
         m.output(str(e)) 
                  
         result = 'Handler exception: '+str(e)
         status ='failed'

      response = response_wrapper(status,result)
      return response

   if command == 'DeleteProject':
      try:
         projectname = argu[0].childNodes[0].data
         result = conn.DeleteProject(projectname)
         result_list = ['DB not open yet','No Exist']

         if result in result_list:
            status = 'failed'
            m.output(result)
         elif 'DB exception' in result:
            status = 'failed'
            m.output(result)
         else:
            status = 'ok'
            m.output(result)
            m.output('\nDone')

      except exceptions.Exception, e:
         m.output('\ncatch exception:')
         m.output(str(e)) 
                  
         result = 'Handler exception: '+str(e)
         status ='failed'

      response = response_wrapper(status,result)
      return response
         
   if command == 'Version':         
      try:               
         result = conn.Version()
         status = 'ok'
         
      except exceptions.Exception, e:
         m.output('\ncatch exception:')
         m.output(str(e)) 
         result = 'Handler exception: '+str(e)
         status = 'failed'
      response = response_wrapper(status,result)
      return response

   if command == 'UpdateData':
      result_list = ['DB not open yet']
      try:
         factid = argu[0].childNodes[0].data
         value = argu[1].childNodes[0].data

         result = conn.UpdateData(factid,value)
         result = str(result)

         if result in result_list:
            status = 'failed'
            m.output(result)

         elif 'DB exception' in result:
            status = 'failed'
            m.output(result)
         else:
            status = 'ok'
            m.output(result)
            m.output('\nDone!')
      except exceptions.Exception,e:
         m.output('\nCatch exception:')
         m.output(str(e))
         result = 'Handler exception: '+str(e)
         status = 'failed'
      response = response_wrapper(status,result)
      return response
                  
   if command == 'GetJobid':
      result_list = ['DB not open yet','No such a project','No such a job']
      try:
         projectname = argu[0].childNodes[0].data
         jobname = argu[1].childNodes[0].data

         result = conn.GetJobid(projectname,jobname)
         result = str(result)

         if result in result_list:
            status = 'failed'
            m.output(result)

         elif 'DB exception' in result:
            status = 'failed'
            m.output(result)
         else:
            status = 'ok'
            m.output(result)
            m.output('\nDone')
      except exceptions.Exception,e:
         m.output('\nCatch exception:')
         m.output(str(e))
         result = 'Handler exception: '+str(e)
         status = 'failed'
      response = response_wrapper(status,result)
      return response
   
   if command == 'GetJobname':
      result_list = ['DB not open yet','Not such a job']
      try:
         jobid = argu[0].childNodes[0].data
         result = conn.GetJobname(jobid)
         result = str(result)

         if result in result_list:
            status = 'failed'
            m.output(result)
         elif 'DB exception' in result:
            status = 'failed'
            m.output(result)
         else:
            status = 'ok'
            m.output(result)
            m.output('\Done')
      except exceptions.Exception,e:
         m.output('\nCatch exception:')
         m.output(str(e))
         result = 'Handler exception: '+str(e)
         status = 'failed'
      response = response_wrapper(status,result)
      return response

def handlechild(clientsock):
  mydb = db.DB()
  m.output('New child')
  m.output(currentThread().getName())
  m.output("Got connection from")
  m.output(str(clientsock.getpeername()))
  m.output("Processing the request...")
  command_list = ['OpenDB','CloseDB','NewProject','NewJob','SetData','GetData','ListProjects','ListJobs','ListItems','Version','GetProject','ImportDingbat','ExportDingbat','DescribeDingbat','DeleteDingbat','DeleteProject','IsOpen','UpdateData','GetJobid','GetJobname']
  
  try:
    while 1:
        data = clientsock.recv(40960)
        m.output('receiving data: ')
        m.output(data)
    
        try:
           doc = xml.dom.minidom.parseString(data)
           com = doc.getElementsByTagName("command")
           command = com[0].childNodes[0].data 
           argu = doc.getElementsByTagName("argument")
  
        except exceptions.Exception,e:
           m.output('catch exception: ')
           m.output(str(e))
           status = 'failed'
           result = 'not well form command'
           response = response_wrapper(status,result)
           clientsock.sendall(response)
           break

        if command not in command_list:
           m.output('not valid command')
           status = 'failed'
           result = 'not valid command'
           response = response_wrapper(status,result)
           clientsock.sendall(response)
        
        if command == 'CloseDB':
           try:
              result = mydb.CloseDB()
              if result == 'successful':
                 m.output('Database close.')
                 status = 'ok'
                 response = response_wrapper(status,result)
              else:
                 m.output('Database catch exception.')
                 status = 'failed'
                 response = response_wrapper(status,result)
           except exceptions.Exception,e:
              m.output('catch exception:')
              m.output(str(e))
              result = 'Handler exception: '+str(e)
              status = 'failed'
              response = response_wrapper(status,result)
           clientsock.sendall(response)
           m.output('Disconnected from')
           m.output(str(clientsock.getpeername())) 
           clientsock.close()
         
           break

        else:
           response =  doCommand(mydb,command,argu)
           m.output('sending data: ')
           m.output(response)
           clientsock.sendall(response)    
  finally: 
    clientsock.close()


def sockfactory():
   #Create a socket
   s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)

   #Ensure that you can restart your server quickly when it terminates
   s.setsockopt(socket.SOL_SOCKET,socket.SO_REUSEADDR, 1)

   #Set port number
   s.bind(('',port))

   #Set the number of clients waiting for connection that can be queued
   s.listen(5)
   return s

   #loop waiting for connections (terminate with Ctrl-C)

def do_serve(s):
   try:
     while 1:
        try: 
            clientsock,clientaddr = s.accept()
            
            m.output("Connected from")
            m.output(str(clientaddr))

        except KeyboardInterrupt:
            raise
        except exceptions.Exception,e:
            m.output('\ncatch exception:')
            m.output(str(e)) 
            traceback.print_exc()
            continue
    
        t = Thread(target = handlechild,args = [clientsock])
        t.setDaemon(1)
        t.start()
    
   finally:
      s.close()

if __name__ == '__main__':

   if not version_check():
       print 'python version must be greater than 2.3'
       sys.exit(0)

   host = ''
   port = 8883
   
   if '-debug' in sys.argv:
     debug = True
     m = messager(True)
   else:
     m = messager(False)
   s = sockfactory()
   do_serve(s)
   m.close()
